Bug 430106 - nspluginwrapper prevents java-1.6.0-openjdk-plugin's correct operation
nspluginwrapper prevents java-1.6.0-openjdk-plugin's correct operation
Status: CLOSED WORKSFORME
Product: Fedora
Classification: Fedora
Component: nspluginwrapper (Show other bugs)
9
x86_64 Linux
low Severity medium
: ---
: ---
Assigned To: Martin Stransky
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-24 10:28 EST by Peter Robinson
Modified: 2008-07-25 03:48 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-07-25 03:48:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
I'm also able to reproduce this, log attached. (21.51 KB, text/plain)
2008-04-15 10:04 EDT, Marek Mahut
no flags Details
sh -x firefox output number 2 (118.22 KB, text/plain)
2008-04-16 17:25 EDT, Peter Robinson
no flags Details

  None (edit)
Description Peter Robinson 2008-01-24 10:28:58 EST
The IBM Remote Supervisor Adapter II card used for Out Of Band management has
the ability to do a remote connection into the console using Java. Under Firefox
on Fedora 8 with icedtea installed this doesn't work.

Details of the RSA card from IBM are:
http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/docdisplay?brandind=5000008&lndocid=MIGR-50116

Running firefox from the commandline using 'firefox -g' as suggested gives the
following output.

Java version is:
java-1.7.0-icedtea-1.7.0.0-0.19.b21.snapshot.fc8
java-1.7.0-icedtea-plugin-1.7.0.0-0.19.b21.snapshot.fc8


unhandled event 19
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
Loading stream: https://mail.google.com/mail/im/sound.swf
GCJ PLUGIN: thread 0x822660: NP_GetValue
GCJ PLUGIN: thread 0x822660: NP_GetValue: returning plugin description.
GCJ PLUGIN: thread 0x822660: NP_GetValue return
GCJ PLUGIN: thread 0x822660: NP_Initialize
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer
gcjwebplugin.cc:1045: thread 0x822660: Error: Failed to spawn applet viewer:
Failed to execute child process
"/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer" (No such file or
directory)
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer return
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog return
GCJ PLUGIN: thread 0x822660: NP_Shutdown
GCJ PLUGIN: thread 0x822660: NP_Shutdown return
LoadPlugin: failed to initialize shared library
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so
[/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so: undefined symbol:
_ZN13nsTArray_base9sEmptyHdrE]
GCJ PLUGIN: thread 0x822660: NP_GetValue
GCJ PLUGIN: thread 0x822660: NP_GetValue: returning plugin description.
GCJ PLUGIN: thread 0x822660: NP_GetValue return
GCJ PLUGIN: thread 0x822660: NP_Initialize
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer
gcjwebplugin.cc:1045: thread 0x822660: Error: Failed to spawn applet viewer:
Failed to execute child process
"/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer" (No such file or
directory)
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer return
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog return
LoadPlugin: failed to initialize shared library
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so
[/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so: undefined symbol:
_ZN13nsTArray_base9sEmptyHdrE]
GCJ PLUGIN: thread 0x822660: NP_Initialize
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer
gcjwebplugin.cc:1045: thread 0x822660: Error: Failed to spawn applet viewer:
Failed to execute child process
"/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer" (No such file or
directory)
GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer return
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog
GCJ PLUGIN: thread 0x822660: plugin_display_failure_dialog return
GCJ PLUGIN: thread 0x822660: NP_Shutdown
GCJ PLUGIN: thread 0x822660: NP_Shutdown return
Comment 1 Thomas Fitzsimmons 2008-01-24 10:48:42 EST
How is the plugin installed?  It needs to be a symlink from a plugins directory
(~/.mozilla/plugins or /usr/lib64/mozilla/plugins) to gcjwebplugin.so, since
gcjwebplugin.so searches relative to its installed location for
"pluginappletviewer".
Comment 2 Thomas Fitzsimmons 2008-01-24 10:51:21 EST
(In reply to comment #1)
> How is the plugin installed?  It needs to be a symlink from a plugins directory
> (~/.mozilla/plugins or /usr/lib64/mozilla/plugins) to gcjwebplugin.so, since
> gcjwebplugin.so searches relative to its installed location for
> "pluginappletviewer".

I should also note that java-1.7.0-icedtea-plugin should "Just Work", since it
installs an alternatives-managed symlink in /usr/lib64/mozilla/plugins/ to
/etc/alternatives/libjavaplugin.so which in turn links to the installed
gcjwebplugin.so.

Can you post the output of:

readlink -f /usr/lib64/mozilla/plugins/libjavaplugin.so
Comment 3 Peter Robinson 2008-01-24 11:04:46 EST
The plugin is installed however rpm installs the package from the
Fedora8/Fedora8updates rpms. I've done nothing else. I can force a reinstall of
the java rpms if you like.

[root@euuklonw7300b1n ~]# readlink -f /usr/lib64/mozilla/plugins/libjavaplugin.so
/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
[root@euuklonw7300b1n ~]# 
Comment 4 Thomas Fitzsimmons 2008-01-24 14:57:03 EST
I wonder why it's looking for
/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer.  On my Rawhide x86_64
system, with

firefox-3.0-0.beta2.12.nightly20080121.fc9
java-1.7.0-icedtea-plugin-1.7.0.0-0.23.b24.snapshot.fc9

it looks for and finds:

/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/../../bin/pluginappletviewer

A few more questions:

Do any applets load for you in Firefox?

Can you post the output of:

find ~/.mozilla/plugins
find /usr/lib/mozilla/plugins
find /usr/lib64/mozilla/plugins

What version of Firefox are you running?

Do you have nspluginwrapper installed?  If so, what version?
Comment 5 Thomas Fitzsimmons 2008-02-18 17:36:12 EST
Can you provide the information requested in Comment #4?
Comment 6 Peter Robinson 2008-02-19 09:06:55 EST
Hi Thomas,

Yes, I should be able to in the next couple of days, sorry for the delay as I've
been busy.

Peter
Comment 7 Peter Robinson 2008-04-10 08:35:01 EDT
Hi Thomas,

Sorry for the delay. In the mean time I've upgraded to Fedora9/rawhide but I'm
still seeing the same issues. For loading of applets if I go to java.com it
detects java and I have Duke java man running backwards and forwards and it
reports version 1.6.0

Details of installed versions:
[root@euuklonw7300b1n ~]# rpm -q firefox xulrunner nspluginwrapper
firefox-3.0-0.53.beta5.fc9.x86_64
xulrunner-1.9-0.53.beta5.fc9.x86_64
nspluginwrapper-0.9.91.5-26.fc9.x86_64
[root@euuklonw7300b1n ~]# rpm -qa| grep java
java-1.5.0-gcj-1.5.0.0-21.fc9.x86_64
java-1.6.0-openjdk-1.6.0.0-0.7.b08.fc9.x86_64
java-1.6.0-openjdk-plugin-1.6.0.0-0.7.b08.fc9.x86_64

[perobinson@euuklonw7300b1n ~]$ find ~/.mozilla/plugins
find: /home/perobinson/.mozilla/plugins: No such file or directory
[perobinson@euuklonw7300b1n ~]$ find /usr/lib/mozilla/plugins
find: /usr/lib/mozilla: No such file or directory
[perobinson@euuklonw7300b1n ~]$ find /usr/lib64/mozilla/plugins
/usr/lib64/mozilla/plugins
/usr/lib64/mozilla/plugins/libtotem-gmp-plugin.so
/usr/lib64/mozilla/plugins/libtotem-mully-plugin.so
/usr/lib64/mozilla/plugins/libtotem-basic-plugin.xpt
/usr/lib64/mozilla/plugins/libjavaplugin.so
/usr/lib64/mozilla/plugins/libtotem-basic-plugin.so
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so
/usr/lib64/mozilla/plugins/libtotem-mully-plugin.xpt
/usr/lib64/mozilla/plugins/libtotem-narrowspace-plugin.so
/usr/lib64/mozilla/plugins/libtotem-cone-plugin.xpt
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.xpt
/usr/lib64/mozilla/plugins/libtotem-gmp-plugin.xpt
/usr/lib64/mozilla/plugins/libswfdecmozilla.so
/usr/lib64/mozilla/plugins/libtotem-narrowspace-plugin.xpt
/usr/lib64/mozilla/plugins/librhythmbox-itms-detection-plugin.so
/usr/lib64/mozilla/plugins/libtotem-cone-plugin.so
[perobinson@euuklonw7300b1n ~]$ 
Comment 8 Thomas Fitzsimmons 2008-04-10 11:49:30 EDT
Thanks.  Can you post the result of:

readlink -f /usr/lib64/mozilla/plugins/libjavaplugin.so
Comment 9 Thomas Fitzsimmons 2008-04-10 12:01:28 EDT
And also, the results of:

find /usr/lib/mozilla/plugins-wrapped
find /usr/lib64/mozilla/plugins-wrapped

(and readlink -f's of any libjavaplugin.so or gcjwebplugin.so files found there)
Comment 10 Peter Robinson 2008-04-10 13:52:08 EDT
As below

[perobinson@euuklonw7300b1n ~]$ readlink -f
/usr/lib64/mozilla/plugins/libjavaplugin.so
/usr/lib/jvm/java-1.6.0-openjdk-1.6.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
[perobinson@euuklonw7300b1n ~]$ find /usr/lib/mozilla/plugins-wrapped
find: /usr/lib/mozilla: No such file or directory
[perobinson@euuklonw7300b1n ~]$ find /usr/lib64/mozilla/plugins-wrapped
/usr/lib64/mozilla/plugins-wrapped
/usr/lib64/mozilla/plugins-wrapped/libtotem-gmp-plugin.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-mully-plugin.so
/usr/lib64/mozilla/plugins-wrapped/nswrapper_64_64.librhythmbox-itms-detection-plugin.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-basic-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libjavaplugin.so
/usr/lib64/mozilla/plugins-wrapped/nswrapper_64_64.libswfdecmozilla.so
/usr/lib64/mozilla/plugins-wrapped/npwrapper.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-basic-plugin.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-complex-plugin.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-mully-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libtotem-narrowspace-plugin.so
/usr/lib64/mozilla/plugins-wrapped/libtotem-cone-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libtotem-complex-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libtotem-gmp-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libtotem-narrowspace-plugin.xpt
/usr/lib64/mozilla/plugins-wrapped/libtotem-cone-plugin.so
[perobinson@euuklonw7300b1n ~]$ readlink -f
/usr/lib64/mozilla/plugins-wrapped/libjavaplugin.so
/usr/lib/jvm/java-1.6.0-openjdk-1.6.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
[perobinson@euuklonw7300b1n ~]$ 
Comment 11 Thomas Fitzsimmons 2008-04-10 14:27:31 EDT
Can you post the result of:

sh -x /usr/bin/firefox

(make sure that no other firefox instances are running when you check this).

I want to know what MOZ_PLUGIN_DIR is being set to.
Comment 12 Marek Mahut 2008-04-15 10:04:35 EDT
Created attachment 302454 [details]
I'm also able to reproduce this, log attached.
Comment 13 Thomas Fitzsimmons 2008-04-15 14:47:25 EDT
Marek, your problem is:

https://bugzilla.redhat.com/show_bug.cgi?id=304031

I worked around your problem by adding:

        permission java.util.PropertyPermission "user.home", "read";
        permission java.util.PropertyPermission "mcs.debug", "read";
        permission java.io.FilePermission "<<ALL FILES>>", "read";
        permission java.io.FilePermission "<<ALL FILES>>", "write";
        permission java.io.FilePermission "<<ALL FILES>>", "execute";
        permission java.io.FilePermission "<<ALL FILES>>", "delete";
        permission java.lang.RuntimePermission
"loadLibrary./home/cygnus/fitzsim/IBM/virtserver04-mm.intdev.redhat.com/libibmxrdisk.so.1.0.1";

to the grant section of:

/usr/lib/jvm/java-1.6.0-openjdk-1.6.0.0/jre/lib/security/java.policy

I'd recommend only using this workaround for testing though -- it gives all
applets read/write/execute/delete privileges on any file on which you have the
relevant Unix permissions.
Comment 14 Thomas Fitzsimmons 2008-04-15 14:48:45 EDT
Peter, your problem is different in that the appletviewer is not being found. 
I'd like to track it down precisely -- I suspect it has something to do with
nspluginwrapper.  Can you post the output of:

sh -x /usr/bin/firefox
Comment 15 Peter Robinson 2008-04-15 17:44:17 EDT
Hi Thomas,

Sorry for the delay, here's the output of the sh -x. Let me know if you need any
more information, I'm back online again so I should be quicker.

Peter

[perobinson@euuklonw7300b1n ~]$ sh -x /usr/bin/firefox
++ basename /usr/bin/firefox
+ cmdname=firefox
++ uname -m
+ MOZ_ARCH=x86_64
+ case $MOZ_ARCH in
+ MOZ_LIB_DIR=/usr/lib64
+ SECONDARY_LIB_DIR=/usr/lib
+ '[' '!' -x /usr/lib64/firefox-3.0b5/firefox ']'
+ MOZ_DIST_BIN=/usr/lib64/firefox-3.0b5
+ MOZ_EXTENSIONS_DIR=/usr/lib64/firefox-3.0b5/extensions
+ MOZ_PROGRAM=/usr/lib64/firefox-3.0b5/firefox
+ MOZ_LAUCHER=/usr/lib64/firefox-3.0b5/run-mozilla.sh
+ MOZ_GRE_CONF=/etc/gre.d/gre.conf
+ '[' /usr/lib64 == /usr/lib64 ']'
+ MOZ_GRE_CONF=/etc/gre.d/gre64.conf
+ export MOZ_GRE_CONF
+ MOZILLA_FIVE_HOME=/usr/lib64/firefox-3.0b5
+ export MOZILLA_FIVE_HOME
+ '[' -x /usr/bin/mozilla-plugin-config ']'
+ MOZ_PLUGIN_DIR=plugins-wrapped
+ '[' '' ']'
+
MOZ_PLUGIN_PATH=/usr/lib64/mozilla/plugins-wrapped:/usr/lib64/firefox-3.0b5/plugins-wrapped
+ export MOZ_PLUGIN_PATH
+ '[' -x /usr/bin/mozilla-plugin-config ']'
+ /usr/bin/mozilla-plugin-config
+ FONTCONFIG_PATH=/etc/fonts:/usr/lib64/firefox-3.0b5/res/Xft
+ export FONTCONFIG_PATH
+ GNOME_DISABLE_CRASH_DIALOG=1
+ export GNOME_DISABLE_CRASH_DIALOG
+ MOZARGS=
++ echo en_GB.utf8
++ sed 's|_\([^.]*\).*||g'
+ SHORTMOZLOCALE=en
+ '[' -f
/usr/lib64/firefox-3.0b5/extensions/langpack-en@firefox.mozilla.org/chrome/en.jar ']'
++ sed 's|_\([^.]*\).*|-\1|g'
++ echo en_GB.utf8
+ MOZLOCALE=en-GB
+ '[' -f
/usr/lib64/firefox-3.0b5/extensions/langpack-en-GB@firefox.mozilla.org/chrome/en-GB.jar
']'
+ MOZARGS='-UILocale en-GB'
+ script_args=
+ pass_arg_count=0
+ '[' 0 -gt 0 ']'
+ debugging=0
+ '[' 0 = 1 ']'
+ exec /usr/lib64/firefox-3.0b5/run-mozilla.sh /usr/lib64/firefox-3.0b5/firefox
-UILocale en-GB
Unsupported movie property style with value ""
Unsupported movie property id with value "topnav"
Unsupported movie property name with value "topnav"
Unsupported movie property quality with value "high"
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
Unsupported movie property style with value ""
Unsupported movie property id with value "sidenav"
Unsupported movie property name with value "sidenav"
Unsupported movie property quality with value "high"
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
Unsupported movie property style with value ""
Unsupported movie property id with value "banner"
Unsupported movie property name with value "banner"
Unsupported movie property quality with value "high"
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
Unsupported movie property style with value ""
Unsupported movie property id with value "banner"
Unsupported movie property name with value "banner"
Unsupported movie property quality with value "high"
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
unhandled event 19
invalid window given for setup (id 65011716)
invalid window given for setup (id 65011718)
invalid window given for setup (id 65011720)
unhandled event 19
unhandled event 19
unhandled event 19
Loading stream: http://remhq.com/topnav.swf?section=live
Loading stream: http://remhq.com/sidenav.swf?section=livedates
Loading stream: http://remhq.com/images/ss_banner.swf
Loading stream: http://remhq.com/images/ss_banner_small.swf
Unsupported movie property id with value "flash_object"
Unsupported movie property style with value "position: absolute; top: 1px; left:
1px; height: 1px; width: 1px;"
Unsupported movie property quality with value "high"
Unsupported movie property pluginspage with value
"http://www.macromedia.com/go/getflashplayer"
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
*** NSPlugin Wrapper *** WARNING: unhandled variable 11 in NPP_GetValue()
invalid window given for setup (id 65011722)
Loading stream: https://mail.google.com/mail/im/sound.swf
Comment 16 Peter Robinson 2008-04-15 17:45:47 EDT
BTW I had a number of various tabs open that were restored when that was run.
Comment 17 Thomas Fitzsimmons 2008-04-15 18:29:51 EDT
What happens if you move /usr/bin/mozilla-plugin-config to /tmp then re-run firefox?
Comment 18 Peter Robinson 2008-04-16 17:25:13 EDT
Created attachment 302677 [details]
sh -x firefox output number 2

A whole lot more than I've ever seen before :-) Although I can't properly test
the actual RSA applet as I'm out of the office so don't have access to the rule
range of ports that the applet seems to need.

Its looking a lot better than it has done in the past. What does
mozilla-plugin-config do. Attaching a 'sh -x firefox' capture file as its too
big to post here.
Comment 19 Thomas Fitzsimmons 2008-04-16 17:31:36 EDT
Re-assigning to the nspluginwrapper maintainer.
Comment 20 Martin Stransky 2008-04-23 04:08:08 EDT
Why do you think it's a problem in nspluginwrapper? Java plugins are excluded
from wrapping and are just linked. For sure - remove the nspluginwrapper package
(386 and x86_64) and try the java again.
Comment 21 Peter Robinson 2008-04-23 04:13:40 EDT
I was asked in comment #17 to move the mozilla-plugin-config and retry. It then
started working. If I remove nspluginwrapper it works. If I install it in
doesn't. Already tried that and hence why it was reassigned by Thomas.
Comment 22 Martin Stransky 2008-04-23 04:48:38 EDT
Did you restart firefox after nsplugiwrapper installation / removal? Firefox
sets the plugin paths when starts. Mozilla-plugin-config alone doesn't affect
much there. Please install nspluginwrapper, restart the firefox (close all
windows) and run again. If the java doesn't work (works fine for me with and w/o
the wrapper) please attach outputs of:

ll /usr/lib64/mozilla/plugins
ll /usr/lib64/mozilla/plugins-wrapped
Comment 23 Peter Robinson 2008-04-23 04:55:11 EDT
It was restarted for each attempt. See the attachment in comment 18 for the
startup without nspluginwrapper there, see the details in comment 15 for details
of startup with nspluginwrapper
Comment 24 Martin Stransky 2008-04-23 05:04:11 EDT
Okay, please attach the lists of dirs. I don't see anything related in comment
15. All errors comes from flash player, not from java.
Comment 25 Peter Robinson 2008-04-23 08:42:23 EDT
Directories below:

[perobinson@euuklonw7300b1n ~]$ ll /usr/lib64/mozilla/plugins
total 732
lrwxrwxrwx 1 root root     41 2008-03-17 21:16 libjavaplugin.so ->
/etc/alternatives/libjavaplugin.so.x86_64
-rwxr-xr-x 1 root root   5624 2008-04-08 15:14 librhythmbox-itms-detection-plugin.so
-rwxr-xr-x 1 root root  54000 2008-02-20 19:26 libswfdecmozilla.so
-rwxr-xr-x 1 root root  75304 2008-04-08 15:20 libtotem-basic-plugin.so
-rw-r--r-- 1 root root    191 2008-04-08 15:20 libtotem-basic-plugin.xpt
-rwxr-xr-x 1 root root 101448 2008-04-08 15:20 libtotem-complex-plugin.so
-rw-r--r-- 1 root root   3251 2008-04-08 15:20 libtotem-complex-plugin.xpt
-rwxr-xr-x 1 root root  86712 2008-04-08 15:20 libtotem-cone-plugin.so
-rw-r--r-- 1 root root   1339 2008-04-08 15:20 libtotem-cone-plugin.xpt
-rwxr-xr-x 1 root root 111320 2008-04-08 15:20 libtotem-gmp-plugin.so
-rw-r--r-- 1 root root   4504 2008-04-08 15:20 libtotem-gmp-plugin.xpt
-rwxr-xr-x 1 root root  79912 2008-04-08 15:20 libtotem-mully-plugin.so
-rw-r--r-- 1 root root   1237 2008-04-08 15:20 libtotem-mully-plugin.xpt
-rwxr-xr-x 1 root root  97040 2008-04-08 15:20 libtotem-narrowspace-plugin.so
-rw-r--r-- 1 root root   2235 2008-04-08 15:20 libtotem-narrowspace-plugin.xpt
[perobinson@euuklonw7300b1n ~]$ ll /usr/lib64/mozilla/plugins-wrapped
total 156
lrwxrwxrwx 1 root root    43 2008-04-23 10:33 libjavaplugin.so ->
/usr/lib64/mozilla/plugins/libjavaplugin.so
lrwxrwxrwx 1 root root    64 2008-04-23 10:33
librhythmbox-itms-detection-plugin.so ->
/usr/lib64/mozilla/plugins/librhythmbox-itms-detection-plugin.so
lrwxrwxrwx 1 root root    51 2008-04-23 10:33 libtotem-basic-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-basic-plugin.so
lrwxrwxrwx 1 root root    52 2008-04-23 10:33 libtotem-basic-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-basic-plugin.xpt
lrwxrwxrwx 1 root root    53 2008-04-23 10:33 libtotem-complex-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.so
lrwxrwxrwx 1 root root    54 2008-04-23 10:33 libtotem-complex-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-complex-plugin.xpt
lrwxrwxrwx 1 root root    50 2008-04-23 10:33 libtotem-cone-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-cone-plugin.so
lrwxrwxrwx 1 root root    51 2008-04-23 10:33 libtotem-cone-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-cone-plugin.xpt
lrwxrwxrwx 1 root root    49 2008-04-23 10:33 libtotem-gmp-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-gmp-plugin.so
lrwxrwxrwx 1 root root    50 2008-04-23 10:33 libtotem-gmp-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-gmp-plugin.xpt
lrwxrwxrwx 1 root root    51 2008-04-23 10:33 libtotem-mully-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-mully-plugin.so
lrwxrwxrwx 1 root root    52 2008-04-23 10:33 libtotem-mully-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-mully-plugin.xpt
lrwxrwxrwx 1 root root    57 2008-04-23 10:33 libtotem-narrowspace-plugin.so ->
/usr/lib64/mozilla/plugins/libtotem-narrowspace-plugin.so
lrwxrwxrwx 1 root root    58 2008-04-23 10:33 libtotem-narrowspace-plugin.xpt ->
/usr/lib64/mozilla/plugins/libtotem-narrowspace-plugin.xpt
lrwxrwxrwx 1 root root    39 2008-04-23 10:33 npwrapper.so ->
/usr/lib64/nspluginwrapper/npwrapper.so
-rwxr-xr-x 1 root root 82608 2008-04-23 10:33 nswrapper_64_64.libswfdecmozilla.so
[perobinson@euuklonw7300b1n ~]$ 
Comment 26 Martin Stransky 2008-04-23 08:47:52 EDT
libjavaplugin.so is properly linked to
/usr/lib64/mozilla/plugins/libjavaplugin.so, not wrapped. I don't see any
problem here. What says about:plugins, is the java listed there?
Comment 27 Peter Robinson 2008-04-23 09:00:20 EDT
This is what I see in about:plungins

GCJ Web Browser Plugin (using IcedTea) 1.0

    File name: gcjwebplugin.so
    The GCJ Web Browser Plugin (using IcedTea) executes Java applets.

MIME Type 	Description 	Suffixes 	Enabled
application/x-java-vm 	IcedTea 	class,jar 	Yes
application/x-java-applet 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.1 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.1.1 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.1.2 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.1.3 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.2 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.2.1 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.2.2 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.3 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.3.1 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.4 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.4.1 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.4.2 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.5 	IcedTea 	class,jar 	Yes
application/x-java-applet;version=1.6 	IcedTea 	class,jar 	Yes
application/x-java-applet;jpi-version=1.6.0_00 	IcedTea 	class,jar 	Yes
application/x-java-bean 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.1 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.1.1 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.1.2 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.1.3 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.2 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.2.1 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.2.2 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.3 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.3.1 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.4 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.4.1 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.4.2 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.5 	IcedTea 	class,jar 	Yes
application/x-java-bean;version=1.6 	IcedTea 	class,jar 	Yes
application/x-java-bean;jpi-version=1.6.0_00 	IcedTea 	class,jar 	Yes
Comment 28 Martin Stransky 2008-04-23 09:14:30 EDT
The plugin looks sane...do you still the problem?
Comment 29 Peter Robinson 2008-04-23 10:16:26 EDT
Yes. Exactly as before in the top of the ticket. The 'do I have java' detection
on the java.com site detects it but nothing works. 
Comment 30 Martin Stransky 2008-04-23 10:22:52 EDT
I can I reproduce it somehow? Do you have any page what where java doesn't work
with nspluginwrapper?
Comment 31 Thomas Fitzsimmons 2008-04-24 11:53:37 EDT
http://java.com/en/download/installed.jsp?detect=jre&try=1

But the problem doesn't depend on the page loaded.

gcjwebplugin spawns a binary called pluginappletviewer in a separate process to
do the applet loading.  gcjwebplugin finds that binary relative to its own
installation path, which it retrieves using dladdr.

The failure you'll see when you reproduce it is, somewhere in the firefox -g output:

GCJ PLUGIN: thread 0x822660: plugin_test_appletviewer
gcjwebplugin.cc:1045: thread 0x822660: Error: Failed to spawn applet viewer:
Failed to execute child process
"/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer" (No such file or
directory)

This only happens when the

[ -x /usr/bin/mozilla-plugin-config ]

check in the firefox launcher returns true.

It may be enough to exclude plugins named *javaplugin* from recognized by
nspluginwrapper.
Comment 32 Thomas Fitzsimmons 2008-04-24 11:57:26 EDT
I'm updating my x86-64 box to Rawhide so that I can try to reproduce this myself.
Comment 33 Martin Stransky 2008-04-24 12:07:49 EDT
The java test (http://java.com/en/download/help/testvm.xml?ff3) works fine with
nspluginwrapper for me.

You say the binary is detected - but

/usr/lib64/mozilla/plugins/../../bin/pluginappletviewer

is the same dir as

/usr/lib64/mozilla/plugins-wrapped/../../bin/pluginappletviewer

right?

I got (with the wrapper installed):

For application/x-java-vm found plugin
/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
LoadPlugin()
/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
returned 1431500
GCJ PLUGIN: thread 0x6203c0: NP_Initialize
GCJ PLUGIN: thread 0x6203c0: plugin_test_appletviewer
GCJ PLUGIN: thread 0x6203c0: plugin_test_appletviewer return
GCJ PLUGIN: thread 0x6203c0: NP_Initialize: using
/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/../../bin/pluginappletviewer
GCJ PLUGIN: thread 0x6203c0: NP_Initialize return
GCJ PLUGIN: thread 0x6203c0: GCJ_New
GCJ PLUGIN: thread 0x6203c0: plugin_data_new
GCJ PLUGIN: thread 0x6203c0: plugin_data_new return
GCJ PLUGIN: thread 0x6203c0: plugin_get_documentbase
GCJ PLUGIN: thread 0x6203c0: plugin_get_documentbase return
GCJ PLUGIN: thread 0x6203c0: GCJ_New: creating input fifo:
/home/komat/.gcjwebplugin/gcj-instance-8979-0-appletviewer-to-plugin
GCJ PLUGIN: thread 0x6203c0: GCJ_New: created input fifo:
/home/komat/.gcjwebplugin/gcj-instance-8979-0-appletviewer-to-plugin
GCJ PLUGIN: thread 0x6203c0: GCJ_New: creating output fifo:
/home/komat/.gcjwebplugin/gcj-instance-8979-0-plugin-to-appletviewer
GCJ PLUGIN: thread 0x6203c0: GCJ_New: created output fifo:
/home/komat/.gcjwebplugin/gcj-instance-8979-0-plugin-to-appletviewer
GCJ PLUGIN: thread 0x6203c0: plugin_start_appletviewer
GCJ PLUGIN: thread 0x6203c0: plugin_start_appletviewer return
GCJ PLUGIN: thread 0x6203c0: GCJ_New: got confirmation that appletviewer is running.
GCJ PLUGIN: thread 0x6203c0: plugin_create_applet_tag
  PIPE: appletviewer wrote: running
GCJ PLUGIN: thread 0x6203c0: plugin_create_applet_tag return
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: instance-8979-0
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: tag http://java.com/en/download/help/testvm.xml?ff3 <EMBED
CODE="testvm.class" CODEBASE="../../../applet" HEIGHT="250" WIDTH="390" ><PARAM
NAME="alt" VALUE="Java Runtime Environment is not working on your system"><PARAM
NAME="border" VALUE="0"></EMBED>
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: GCJ_New return
  PIPE: appletviewer read: instance-8979-0
  PIPE: appletviewer read: tag http://java.com/en/download/help/testvm.xml?ff3
<EMBED CODE="testvm.class" CODEBASE="../../../applet" HEIGHT="250" WIDTH="390"
><PARAM NAME="alt" VALUE="Java Runtime Environment is not working on your
system"><PARAM NAME="border" VALUE="0"></EMBED>
For application/x-java-vm found plugin
/usr/lib/jvm/java-1.7.0-icedtea-1.7.0.0.x86_64/jre/lib/amd64/gcjwebplugin.so
GCJ PLUGIN: thread 0x6203c0: NP_GetValue
GCJ PLUGIN: thread 0x6203c0: NP_GetValue: returning plugin description.
GCJ PLUGIN: thread 0x6203c0: NP_GetValue return
GCJ PLUGIN: thread 0x6203c0: GCJ_GetValue
GCJ PLUGIN: thread 0x6203c0: GCJ_GetValue: returning TRUE for NeedsXEmbed.
GCJ PLUGIN: thread 0x6203c0: GCJ_GetValue return
nsPluginNativeWindowGtk2: NPPVpluginNeedsXEmbed=1
nsPluginNativeWindowGtk2: call SetWindow with xid=0x2401412
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow: setting window.
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: instance-8979-0
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: handle 37753874
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow return
  PIPE: appletviewer read: instance-8979-0nsPluginNativeWindowGtk2: call
SetWindow with xid=0x2401412
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow: window already exists.
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow: window width changed.
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: instance-8979-0
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: width 390
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow: window height changed.
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: instance-8979-0
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer
  PIPE: plugin wrote: height 250
GCJ PLUGIN: thread 0x6203c0: plugin_send_message_to_appletviewer return
GCJ PLUGIN: thread 0x6203c0: GCJ_SetWindow return

  PIPE: appletviewer read: handle 37753874
  PIPE: appletviewer wrote: status Applet loaded.
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback: setting status Applet loaded.
  PIPE: plugin read: status Applet loaded.
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback return
Debug testGetting document container, &mDocumentContainer = 0x741ed8
Getting document container, mDocumentContainer.get() = 0xc447d0
Getting document container, nsISupport  = 0x2aaaad3f0690
Getting document container, this = 0x741e90
TestVM 3.3 sc
Copyright (c) 2007 Sun Microsystems, Inc.
All Rights Reserved.
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback: setting status Applet
initialized.
  PIPE: plugin read: status Applet initialized.
GCJ PLUGIN: thread 0x6203c0: plugin_in_pipe_callback return

... and so on.
Comment 34 Thomas Fitzsimmons 2008-04-25 18:01:21 EDT
I'm also having trouble reproducing this.  I'd like to keep trying though, since
I've heard other informal reports of the same problem in the past.

Peter, what do:

/usr/sbin/alternatives --display libjavaplugin.so.x86_64

and

/usr/sbin/alternatives --display libjavaplugin.so

report?
Comment 35 Thomas Fitzsimmons 2008-04-25 18:17:49 EDT
My only theories at this point are:

1) Something went wrong with alternatives when upgrading from java-1.7.0-icedtea
   plugin to java-1.6.0-openjdk-plugin.

2) This section of code in gcjwebplugin.cc is only following one symbolic link in
   the chain:

   /usr/lib64/mozilla/plugins-wrapped/libjavaplugin.so
   /usr/lib64/mozilla/plugins/libjavaplugin.so
   /etc/alternatives/libjavaplugin.so.x86_64
   /usr/lib/jvm/jre-1.6.0-openjdk.x86_64/lib/amd64/gcjwebplugin.so

  // Set appletviewer_executable.
  Dl_info info;
  if (dladdr ((const void*) GCJ_New, &info) == 0)
    {
      PLUGIN_ERROR_TWO ("Failed to determine plugin shared object filename",
                        dlerror ());
      np_error = NPERR_GENERIC_ERROR;
      goto cleanup_data_directory;
    }
  filename = g_strdup (info.dli_fname);

3) /usr/lib64/mozilla/plugins/libjavaplugin.so is some file type other than a
   symbolic link

Peter, can also you post the output of:

file /usr/lib64/mozilla/plugins-wrapped/libjavaplugin.so
file /usr/lib64/mozilla/plugins/libjavaplugin.so
file /etc/alternatives/libjavaplugin.so.x86_64
file /usr/lib/jvm/jre-1.6.0-openjdk.x86_64/lib/amd64/gcjwebplugin.so
Comment 36 Thomas Fitzsimmons 2008-04-25 19:19:10 EDT
Peter, one more bit of information.  Can you post the bzip2'd result of:

strace -fFv -s300 firefox >& firefox.log

for the failing case, where, starting with no other firefox instances running,
you visit thisiscool.com, then quit firefox?
Comment 37 Bug Zapper 2008-05-14 00:52:29 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 38 Brennan Ashton 2008-06-07 21:15:03 EDT
Reporter, could you please reply to the previous question? If you won't reply in
one month, I will have to close this bug as INSUFFICIENT_DATA. Thank you.
Comment 39 Peter Robinson 2008-06-16 06:13:41 EDT
Which one? the strace one? I don't think closing the bug as insufficient_data is
appropriate while the bug is still in a relevant release. Fortunately my life
doesn't resolve around a bug in bugzilla and I've had to be in Windows so I can
do my job due to this. I'm off this week and I'm hoping to get time to do the
strace in the next day or so. I've also found another test case other than IBM
RSA server cards that I see this same issue against which is much easier to
test. The upload applet in gallery (gallery.sf.net).
Comment 40 Martin Stransky 2008-07-25 03:48:06 EDT
java-1.6.0-openjdk-plug-in is handled properly with nspluginwrapper. If you
still have a problem with it, please report a new bug against
java-1.6.0-openjdk-plug-in component.

Note You need to log in before you can comment on or make changes to this bug.